/**
 * Ratcom <br>
 * Copyright (c) 2010,  <br>
 * All rights reserved.<br>
 * The authors reserve all rights over the content of this file<br>
 * Any use\copy\alteration of it must be athorized by the authors<br> 
 * 
 * @date Dec 5, 2010 - 10:55:43 PM 
 * @author Daniel Camara - danielcamara@gmail.com
 */
package fr.eurecom.ratcom;

import fr.eurecom.ratcom.gui.RatcomAlertClient;
import fr.eurecom.ratcom.multicast.Multicast;
import fr.eurecom.ratcom.properties.ProjectProperties;
import fr.eurecom.ratcom.util.Logging;
import fr.eurecom.ratcom.util.StringHandler;
import fr.eurecom.ratcom.vrsu.VirtualRoadSideThread;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import com.sun.mail.handlers.message_rfc822;

/**
 * Ratcom <br>
 * 
 * @file multicast.ClientDeamon.java
 * @author daniel
 * @date Dec 5, 2010 - 10:55:43 PM
 */
public class ClientDeamon implements Ratcom {
	private JFrame mainFrame = null;

	private RatcomAlertClient ratcomAlertClient;

	private static ProjectProperties properties = ProjectProperties
			.getInstance();

	private static Multicast multicastClient;

	static Logging logging = Logging.getLogger();// ("smsLog.txt");

	public ClientDeamon() {
		mainFrame = initWindow();
	}

	int nReceivedMessages = 0;

	public void showNewMessage(String msg, int id) {
		if (!mainFrame.isVisible()) {
			mainFrame.setVisible(true);
		}
		ratcomAlertClient.setAlert(msg, id);
		logging.logln("Ratcom Client: new msg: " + msg);
	}

	public void showEmptyMessage() {
		ratcomAlertClient.receivedKeepAlive();
		logging.logln("Ratcom Client: empty msg");
	}

	public JFrame initWindow() {
		JFrame frame = new JFrame();
		frame.setSize(1100, 580);
		frame.setLocation(100, 100);
		ratcomAlertClient = new RatcomAlertClient();
		frame.getContentPane().add(ratcomAlertClient);

		logging.logln("Ratcom Client: Init ");
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				mainFrame.setVisible(false);
				ratcomAlertClient.cleanFields();
				logging.logln("Ratcom Client: Minimize ");
				// System.exit(0);
			}
		});

		// frame.setVisible(true);
		return frame;

	}

	/**
	 * 
	 * 
	 * @date Dec 6, 2010 - 12:11:28 AM : daniel
	 */
	public void handleMessages() {

		while (true) {
			String msg = multicastClient.clientReceive();
			msg = StringHandler.removeEmpty(msg);
			logging.logln("Ratcom Client: received msg: " + msg);

			// (char)(msg.getBytes()[50]);
			if (msg.isEmpty()) {
				showEmptyMessage();
			} else {
				String[] splitedMsg = msg.split(properties.ID_Separator);
				int id = 0;
				if (splitedMsg.length > 2)
					id = Integer.parseInt(splitedMsg[1]);
				showNewMessage(" >>>> Received via Multicast <<<< \n" + msg, id);
				if(properties.startVRSU){
					vRSU.rebroadcastMessage(id, msg);
				}
			}
		}

	}

	/**
	 * @param args
	 * 
	 * @date Dec 5, 2010 - 10:55:43 PM : daniel
	 */
	public static void main(String[] args) {
		ClientDeamon clientDeamon = new ClientDeamon();
		multicastClient = new Multicast();
		boolean clientOk = multicastClient.createClient();

		if (!clientOk) {
			System.out.println("Could not create the client!!! \nExiting!!!\n");
			System.exit(1);
		}
		
		if (properties.startVRSU) {
			clientDeamon.enableVRSU();
		}
		clientDeamon.handleMessages();
	}

	VirtualRoadSideThread vRSU;

	public void enableVRSU() {
		if (vRSU == null) {
			vRSU = new VirtualRoadSideThread(this);
			vRSU.start();
		}
	}

	public void disaleVRSU() {
		// vRSU.stop();
		vRSU = null;
	}

}
