package fr.eurecom.ratcom.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

import com.jeta.forms.components.image.ImageComponent;
import com.jeta.forms.components.line.HorizontalLineComponent;
import com.jeta.forms.components.separator.TitledSeparator;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

import fr.eurecom.ratcom.Ratcom;
import fr.eurecom.ratcom.gui.RatcomAlertClient.ShowButtonThread;
import fr.eurecom.ratcom.properties.ProjectProperties;

public class RatcomAlertServer extends JPanel {
	static ProjectProperties properties = ProjectProperties.getInstance();

	JPanel mainGrid = new JPanel() {
		@Override
		protected void paintComponent(Graphics grphcs) {
			Graphics2D g2d = (Graphics2D) grphcs;
			g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);

			GradientPaint gp = new GradientPaint(0, 100, new Color(192, 208,
					255), 0, getHeight(), new Color(58, 125, 249));
			g2d.setPaint(gp);
			g2d.fillRect(0, 0, getWidth(), getHeight());

			super.paintComponent(grphcs);
		}
	};

	ImageComponent imagecomponent1 = new ImageComponent();

	ImageComponent imagecomponent2 = new ImageComponent();

	ImageComponent msgReceivedButton = new ImageComponent();

	ImageComponent alertReceivedButton = new ImageComponent();

	JButton dismissAlert = new JButton();

	JLabel title = new JLabel();

	HorizontalLineComponent horizontallinecomponent1 = new HorizontalLineComponent();

	JTabbedPane tabPane = new JTabbedPane();

	JPanel gridMessage = new JPanel();

	JTextArea alertArea = new JTextArea();

	JPanel gridConfig = new JPanel();

	JLabel emailRefreshTime = new JLabel();

	JLabel imapLebel = new JLabel();

	JLabel emailLabel = new JLabel();

	JLabel passwordLabel = new JLabel();

	JLabel portLabel = new JLabel();

	static JFormattedTextField emailRefreshProperty = new JFormattedTextField();

	static JFormattedTextField imapProperty = new JFormattedTextField();

	static JFormattedTextField portProperty = new JFormattedTextField();

	static JFormattedTextField eMailProperty = new JFormattedTextField();

	static JFormattedTextField passwordProperty = new JFormattedTextField();

	JLabel mAddressLabel = new JLabel();

	JLabel mPortLabel = new JLabel();

	static JFormattedTextField mAddressProperty = new JFormattedTextField();

	static JFormattedTextField mPortProperty = new JFormattedTextField();

	static JFormattedTextField keepAliveProperty = new JFormattedTextField();

	JButton updateFieldsButton = new JButton();

	JLabel enablevRSULabel = new JLabel();

	static JCheckBox enablevRSUCheck = new JCheckBox();

	JLabel messages = new JLabel();

	JLabel vRSUPortLabel = new JLabel();

	JLabel nRebroadcastsLabel = new JLabel();

	JLabel maxRebroadcastLabel = new JLabel();

	static JFormattedTextField nRebroadcastProperty = new JFormattedTextField();

	static JFormattedTextField maxRebroadcastProperty = new JFormattedTextField();

	static JFormattedTextField vRSUPortProperty = new JFormattedTextField();

	Graphics g = null;

	private Ratcom ratcom;

	/**
	 * Default constructor
	 */
	public RatcomAlertServer() {
		initializePanel();
		getPreferences();
		g = this.getGraphics();
	}

	/**
	 * Main method for panel
	 */
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.setSize(1000, 640);
		frame.setPreferredSize(new Dimension(1000, 640));
		frame.setLocation(100, 100);
		frame.getContentPane().add(new RatcomAlertServer());
		frame.setVisible(true);

		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				toPreferences();
				properties.saveParameters();
				System.exit(0);
			}
		});
	}

	public void setRatcom(Ratcom ratcom) {
		this.ratcom = ratcom;
	}

	/**
	 * Adds fill components to empty cells in the first row and first column of
	 * the grid. This ensures that the grid spacing will be the same as shown in
	 * the designer.
	 * 
	 * @param cols
	 *            an array of column indices in the first row where fill
	 *            components should be added.
	 * @param rows
	 *            an array of row indices in the first column where fill
	 *            components should be added.
	 */
	void addFillComponents(Container panel, int[] cols, int[] rows) {
		Dimension filler = new Dimension(10, 10);

		boolean filled_cell_11 = false;
		CellConstraints cc = new CellConstraints();
		if (cols.length > 0 && rows.length > 0) {
			if (cols[0] == 1 && rows[0] == 1) {
				/** add a rigid area */
				panel.add(Box.createRigidArea(filler), cc.xy(1, 1));
				filled_cell_11 = true;
			}
		}

		for (int index = 0; index < cols.length; index++) {
			if (cols[index] == 1 && filled_cell_11) {
				continue;
			}
			panel.add(Box.createRigidArea(filler), cc.xy(cols[index], 1));
		}

		for (int index = 0; index < rows.length; index++) {
			if (rows[index] == 1 && filled_cell_11) {
				continue;
			}
			panel.add(Box.createRigidArea(filler), cc.xy(1, rows[index]));
		}

	}

	/**
	 * Helper method to load an image file from the CLASSPATH
	 * 
	 * @param imageName
	 *            the package and name of the file to load relative to the
	 *            CLASSPATH
	 * @return an ImageIcon instance with the specified image file
	 * @throws IllegalArgumentException
	 *             if the image resource cannot be loaded.
	 */
	public ImageIcon loadImage(String imageName) {
		try {
			ClassLoader classloader = getClass().getClassLoader();
			java.net.URL url = classloader.getResource(imageName);
			if (url != null) {
				ImageIcon icon = new ImageIcon(url);
				return icon;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		throw new IllegalArgumentException(properties.loadImageException
				+ imageName);
	}

	/**
	 * Method for recalculating the component orientation for right-to-left
	 * Locales.
	 * 
	 * @param orientation
	 *            the component orientation to be applied
	 */
	public void applyComponentOrientation(ComponentOrientation orientation) {
		// Not yet implemented...
		// I18NUtils.applyComponentOrientation(this, orientation);
		super.applyComponentOrientation(orientation);
	}

	public JPanel createmainGrid() {
		mainGrid.setOpaque(false);
		mainGrid.setName("mainGrid");
		FormLayout formlayout1 = new FormLayout(
				"FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE",
				"CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:MAX(19DLU;DEFAULT):GROW(1.0),CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE");
		// FormLayout formlayout1 = new FormLayout(
		// "FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE",
		// "CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:GROW(1.0),CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE");
		CellConstraints cc = new CellConstraints();
		mainGrid.setLayout(formlayout1);

		imagecomponent1.setIcon(loadImage(properties.eurecomLogo));
		EtchedBorder etchedborder1 = new EtchedBorder(EtchedBorder.LOWERED,
				null, null);
		imagecomponent1.setBorder(etchedborder1);
		mainGrid.add(imagecomponent1, cc.xy(6, 9));

		imagecomponent2.setIcon(loadImage(properties.ratcomLogo));
		EtchedBorder etchedborder2 = new EtchedBorder(EtchedBorder.LOWERED,
				null, null);
		imagecomponent2.setBorder(etchedborder2);
		mainGrid.add(imagecomponent2, cc.xy(8, 9));

		msgReceivedButton.setIcon(loadImage(properties.unabledStatusButton));
		msgReceivedButton.setName("leftStatusButton");
		EtchedBorder etchedborder3 = new EtchedBorder(EtchedBorder.RAISED,
				null, null);
		Border border1 = BorderFactory.createTitledBorder(etchedborder3,
				properties.receivedButtonLabel,
				TitledBorder.DEFAULT_JUSTIFICATION,
				TitledBorder.DEFAULT_POSITION, null, new Color(204, 204, 204));
		msgReceivedButton.setBorder(border1);
		mainGrid.add(msgReceivedButton, cc.xy(10, 9));

		alertReceivedButton.setIcon(loadImage(properties.unabledStatusButton));
		alertReceivedButton.setName("centerStatusButton");
		EtchedBorder etchedborder4 = new EtchedBorder(EtchedBorder.RAISED,
				null, null);
		Border border2 = BorderFactory.createTitledBorder(etchedborder4,
				properties.alertButtonTitle,
				TitledBorder.DEFAULT_JUSTIFICATION,
				TitledBorder.DEFAULT_POSITION, null, new Color(204, 204, 204));
		alertReceivedButton.setBorder(border2);
		mainGrid.add(alertReceivedButton, cc.xy(12, 9));

		dismissAlert.setActionCommand(properties.dismissAlertButton);
		dismissAlert.setBackground(new Color(204, 204, 204));
		dismissAlert.setName("dismissAlert");
		dismissAlert.setRolloverEnabled(true);
		dismissAlert.setText(properties.dismissAlertButton);
		BevelBorder bevelborder1 = new BevelBorder(BevelBorder.RAISED, null,
				null, null, null);
		dismissAlert.setBorder(bevelborder1);
		dismissAlert.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				alertArea.setText("");
			}

		});
		mainGrid.add(dismissAlert, cc.xy(16, 9));

		title.setFont(new Font("Serif", Font.BOLD, 20));
		title.setForeground(new Color(0, 0, 102));
		title.setName("title");
		title.setText(properties.serverTitle);
		mainGrid.add(title, cc.xywh(2, 2, 16, 1));

		mainGrid.add(horizontallinecomponent1, cc.xywh(2, 3, 16, 1));

		tabPane.setName("tabPane");
		tabPane.addTab(properties.msgTabTitle, null, creategridMessage());
		tabPane.addTab(properties.configTabTitle, null, creategridConfig());
		mainGrid.add(tabPane, cc.xywh(2, 4, 16, 2));

		messages.setBackground(new Color(255, 255, 255));
		messages.setForeground(new Color(255, 255, 255));
		messages.setText(properties.initialTextAtMessages);
		EtchedBorder etchedborder5 = new EtchedBorder(EtchedBorder.RAISED,
				null, null);
		Border border3 = BorderFactory.createTitledBorder(etchedborder5,
				properties.receivedMsgsSeparator,
				TitledBorder.DEFAULT_JUSTIFICATION,
				TitledBorder.DEFAULT_POSITION, null, new Color(0, 49, 139));
		messages.setBorder(border3);

		// BorderFactory.createTitledBorder(etchedborder5,
		// "Messages", TitledBorder.DEFAULT_JUSTIFICATION,
		// TitledBorder.DEFAULT_POSITION, null, new Color(49, 106, 196));
		// messages.setBorder(border3);
		mainGrid.add(messages, cc.xywh(2, 11, 16, 1));

		enablevRSULabel.setName("enablevRSULabel");
		enablevRSULabel.setText(properties.enablevRSULabel);
		mainGrid.add(enablevRSULabel, cc.xy(3, 7));

		enablevRSUCheck.setBackground(new Color(255, 255, 255));
		enablevRSUCheck.setName("enablevRSUCheck");
		enablevRSUCheck.setSelected(true);
		EtchedBorder etchedborder6 = new EtchedBorder(EtchedBorder.RAISED,
				null, null);
		enablevRSUCheck.setBorder(etchedborder6);
		enablevRSUCheck.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				properties.startVRSU = enablevRSUCheck.isSelected();
				if(ratcom != null)
					if (enablevRSUCheck.isSelected()) {
						ratcom.enableVRSU();
					}else{
						ratcom.disaleVRSU();
					}

			}

		});
		mainGrid.add(enablevRSUCheck, cc.xy(4, 7));

		// addFillComponents(mainGrid, new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9,
		// 10,
		// 11, 12, 13, 14, 15, 16, 17, 18 }, new int[] { 1, 2, 3, 4, 5, 6,
		// 7, 8, 9, 10, 11, 12 });
		addFillComponents(mainGrid, new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10,
				11, 12, 13, 14, 15, 16, 17, 18 }, new int[] { 1, 2, 3, 4, 5, 6,
				7, 8, 9, 10, 11, 12 });
		return mainGrid;
	}

	public JScrollPane creategridMessage() {
		gridMessage.setName("gridMessage");
		JScrollPane jscrollpane1 = new JScrollPane();
		jscrollpane1.setViewportView(gridMessage);
		jscrollpane1
				.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jscrollpane1
				.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		// FormLayout formlayout1 = new FormLayout(
		// "FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE",
		// "CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:GROW(1.0),CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
		FormLayout formlayout1 = new FormLayout(
				"FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE",
				"CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:GROW(1.0),CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
		CellConstraints cc = new CellConstraints();
		gridMessage.setLayout(formlayout1);

		alertArea.setEditable(false);
		alertArea.setEnabled(false);
		alertArea.setName("alertArea");
		alertArea.setSelectionEnd(6);
		alertArea.setSelectionStart(6);
		// alertArea.setText("aaaaaa");
		EtchedBorder etchedborder1 = new EtchedBorder(EtchedBorder.LOWERED,
				null, null);
		Border border1 = BorderFactory.createTitledBorder(etchedborder1,
				properties.alertFieldTitle, TitledBorder.DEFAULT_JUSTIFICATION,
				TitledBorder.DEFAULT_POSITION, null, new Color(49, 106, 196));
		alertArea.setBorder(border1);
		alertArea.setForeground(new Color(157, 9, 9));
		alertArea.setDisabledTextColor(new Color(157, 9, 9));
		JScrollPane jscrollpane2 = new JScrollPane();
		jscrollpane2.setViewportView(alertArea);
		jscrollpane2
				.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jscrollpane2
				.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		gridMessage.add(jscrollpane2, cc.xywh(1, 1, 8, 5));

		// addFillComponents(gridMessage, new int[] { 2, 3, 4, 5, 6, 7, 8 },
		// new int[] { 2, 3, 4, 5 });
		addFillComponents(gridMessage, new int[] { 2, 3, 4, 5, 6, 7, 8 },
				new int[] { 2, 3, 4, 5 });
		return jscrollpane1;
	}

	public JScrollPane creategridConfig() {
		gridConfig.setName("gridConfig");
		// FormLayout formlayout1 = new FormLayout(
		// "FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE",
		// "CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
		JScrollPane jscrollpane1 = new JScrollPane();
		jscrollpane1.setViewportView(gridConfig);
		jscrollpane1
				.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jscrollpane1
				.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		FormLayout formlayout1 = new FormLayout(
				"FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:8DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE",
				"CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
		CellConstraints cc = new CellConstraints();
		gridConfig.setLayout(formlayout1);

		TitledSeparator titledseparator1 = new TitledSeparator();
		titledseparator1.setText(properties.timersConfSeparator);
		gridConfig.add(titledseparator1, cc.xywh(2, 1, 5, 1));

		emailRefreshTime.setName("emailRefreshTime");
		emailRefreshTime.setText(properties.emailRefreshTimeLabel);
		gridConfig.add(emailRefreshTime, cc.xy(2, 2));

		JLabel jlabel1 = new JLabel();
		jlabel1.setText(properties.multicastKeepAliveLabel);
		gridConfig.add(jlabel1, cc.xy(2, 3));

		imapLebel.setName("imapLebel");
		imapLebel.setText(properties.imapServerLabel);
		gridConfig.add(imapLebel, cc.xy(2, 6));

		emailLabel.setName("emailLabel");
		emailLabel.setText(properties.emailLabel);
		gridConfig.add(emailLabel, cc.xy(2, 8));

		passwordLabel.setName("passwordLabel");
		passwordLabel.setText(properties.passwordLabel);
		gridConfig.add(passwordLabel, cc.xy(2, 9));

		portLabel.setName("portLabel");
		portLabel.setText(properties.portLabel);
		gridConfig.add(portLabel, cc.xy(2, 7));

		emailRefreshProperty.setName("emailProperty");
		gridConfig.add(emailRefreshProperty, cc.xywh(4, 2, 2, 1));

		imapProperty.setName("imapProperty");
		gridConfig.add(imapProperty, cc.xywh(4, 6, 2, 1));

		portProperty.setName("portProperty");
		gridConfig.add(portProperty, cc.xywh(4, 7, 2, 1));

		eMailProperty.setName("eMailProperty");
		gridConfig.add(eMailProperty, cc.xywh(4, 8, 2, 1));

		passwordProperty.setName("passwordProperty");
		gridConfig.add(passwordProperty, cc.xywh(4, 9, 2, 1));

		mAddressLabel.setName("mAddressLabel");
		mAddressLabel.setText(properties.multicastAddressLabel);
		gridConfig.add(mAddressLabel, cc.xy(2, 12));

		mPortLabel.setName("mPortLabel");
		mPortLabel.setText(properties.multicastPortLabel);
		gridConfig.add(mPortLabel, cc.xy(2, 13));

		mAddressProperty.setName("mAddressProperty");
		gridConfig.add(mAddressProperty, cc.xywh(4, 12, 2, 1));

		mPortProperty.setName("mPortProperty");
		gridConfig.add(mPortProperty, cc.xywh(4, 13, 2, 1));

		keepAliveProperty.setName("keepAlidveProperty");
		gridConfig.add(keepAliveProperty, cc.xywh(4, 3, 2, 1));

		TitledSeparator titledseparator2 = new TitledSeparator();
		titledseparator2.setText(properties.alertServerSeparator);
		gridConfig.add(titledseparator2, cc.xywh(2, 5, 5, 1));

		TitledSeparator titledseparator3 = new TitledSeparator();
		titledseparator3.setText(properties.multicastSeparator);
		gridConfig.add(titledseparator3, cc.xywh(2, 11, 5, 1));

		updateFieldsButton.setActionCommand("Update preferences");
		updateFieldsButton.setText(properties.updatePropertiesButton);
		updateFieldsButton.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				toPreferences();
				properties.saveParameters();
			}

		});
		gridConfig.add(updateFieldsButton, cc.xy(5, 20));

		TitledSeparator titledseparator4 = new TitledSeparator();
		titledseparator4.setText(properties.vRSUSeparator);
		gridConfig.add(titledseparator4, cc.xywh(2, 15, 5, 1));

		vRSUPortLabel.setName("vRSUPortLabel");
		vRSUPortLabel.setText(properties.vRSUPortLabel);
		gridConfig.add(vRSUPortLabel, cc.xy(2, 16));

		vRSUPortProperty.setName("vRSUPortProperty");
		gridConfig.add(vRSUPortProperty, cc.xywh(4, 16, 2, 1));

		nRebroadcastsLabel.setName("nRebroadcastsLabel");
		nRebroadcastsLabel.setText(properties.RSUnRebroadcastsLabel);
		gridConfig.add(nRebroadcastsLabel, cc.xy(2, 17));

		maxRebroadcastLabel.setName("maxRebroadcastLabel");
		maxRebroadcastLabel.setText(properties.RSUMaxRebIntervalLabel);
		gridConfig.add(maxRebroadcastLabel, cc.xy(2, 18));

		nRebroadcastProperty.setName("nRebroadcastProperty");
		gridConfig.add(nRebroadcastProperty, cc.xywh(4, 17, 2, 1));

		maxRebroadcastProperty.setName("maxRebroadcastProperty");
		gridConfig.add(maxRebroadcastProperty, cc.xywh(4, 18, 2, 1));

		addFillComponents(gridConfig, new int[] { 1, 3, 4, 5, 6 }, new int[] {
				1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
				19, 20, 21 });

		// addFillComponents(gridConfig, new int[] { 1, 3, 4, 5, 6 }, new int[]
		// {
		// 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 });
		return jscrollpane1;
	}

	/**
	 * Initializer
	 */
	protected void initializePanel() {
		setLayout(new BorderLayout());
		add(createmainGrid(), BorderLayout.CENTER);
	}

	/**
	 * Reads the preferences from the properties and add to the right fields on
	 * the screen
	 */
	private void getPreferences() {
		emailRefreshProperty.setText(properties.sleepingTimeEmailReading + "");
		keepAliveProperty.setText(properties.keepAliveMsg + "");
		imapProperty.setText(properties.host);
		portProperty.setText(properties.port + "");
		eMailProperty.setText(properties.username);
		passwordProperty.setText(properties.password);
		mAddressProperty.setText(properties.multicastGroup);
		mPortProperty.setText(properties.multicastPort + "");
		vRSUPortProperty.setText(properties.vRSU_Port + "");
		nRebroadcastProperty.setText(properties.vRSU_rebroadcastTimes + "");
		maxRebroadcastProperty.setText(properties.vRSU_maxInterval + "");
		enablevRSUCheck.setSelected(properties.startVRSU);
	}

	/**
	 * Stores the fields from the screen to the proper fields in the properties
	 * file
	 */
	public static void toPreferences() {
		properties.sleepingTimeEmailReading = Integer
				.parseInt(emailRefreshProperty.getText());
		properties.keepAliveMsg = Integer.parseInt(keepAliveProperty.getText());
		properties.host = imapProperty.getText();
		properties.port = Integer.parseInt(portProperty.getText());
		properties.username = eMailProperty.getText();
		properties.password = passwordProperty.getText();
		properties.multicastGroup = mAddressProperty.getText();
		properties.multicastPort = Integer.parseInt(mPortProperty.getText());
		properties.vRSU_Port = Integer.parseInt(vRSUPortProperty.getText());
		properties.vRSU_rebroadcastTimes = Integer
				.parseInt(nRebroadcastProperty.getText());
		properties.vRSU_maxInterval = Integer.parseInt(maxRebroadcastProperty
				.getText());
		properties.startVRSU = enablevRSUCheck.isSelected();
	}

	ShowButtonThread sb1;

	ShowButtonThread sb2;

	ShowButtonThread sb3;

	int keepAlive = 0;

	/**
	 * @param msg
	 * 
	 * @date Dec 5, 2010 - 11:09:15 PM : daniel
	 */
	public void receivedKeepAlive() {
		messages.setText(properties.msgKeepAlive + ++keepAlive
				+ properties.msgLastMsgRec + msgNumber);
		sb3 = new ShowButtonThread(msgReceivedButton,
				properties.recMessageButton);
	}

	int msgNumber = 0;

	/**
	 * @param msg
	 * 
	 * @date Dec 5, 2010 - 11:09:15 PM : daniel
	 */
	public void setAlert(String msg, int msgNumber) {
		this.msgNumber = msgNumber;
		alertArea.append(properties.alertMsgHeadrInit + msgNumber
				+ properties.alertMsgHeadrEnd + msg + "\n");
		alertArea.setCaretPosition(alertArea.getText().length());
		messages.setText(properties.msgKeepAlive + keepAlive
				+ properties.msgLastMsgRec + msgNumber);
		sb1 = new ShowButtonThread(msgReceivedButton,
				properties.recMessageButton);
		sb2 = new ShowButtonThread(alertReceivedButton,
				properties.recAlertButton);
	}

	/**
	 * 
	 * Ratcom <br>
	 * 
	 * @file gui.RatcomAlertClient.java
	 * @author daniel
	 * @date Dec 5, 2010 - 11:39:45 PM
	 */
	class ShowButtonThread implements Runnable {

		ImageComponent statusButton;

		String newImage;

		Thread runner;

		public ShowButtonThread() {
		}

		public ShowButtonThread(ImageComponent statusButton, String newImage) {
			runner = new Thread(this, "changeButton"); // (1) Create a new
			// thread.
			this.statusButton = statusButton;
			this.newImage = newImage;
			runner.start(); // (2) Start the thread.
		}

		public void run() {
			// Icon originalImage = statusButton.getIcon();
			statusButton.setIcon(loadImage(newImage));
			repaint();
			try {
				runner.sleep(800);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			statusButton.setIcon(loadImage(properties.unabledStatusButton));
			repaint();
		}
	}

} 